#!/bin/sh
function instt
{
if [ -r $1 ]; then
  printf "Install $1 and ./disk on $2 ? [n/y] "
  read ans
  if [ "$ans" = "y" -o "$ans" = "Y" ]; then
    printf "Installing $1 boot image on $2 ..."
    rm -f /tmp/dd.$$
    dd if=$1 of=/tmp/dd.$$ bs=1k > /tmp/cnt.$$ 2>&1
    rm -f /tmp/dd.$$
    image_size=$(expr $(grep in /tmp/cnt.$$ | cut -d' ' -f1 | sed -e "s/\+/ \+ /"))
    rm -f /tmp/cnt.$$
    offset=$(expr $image_size + 16384)
    dd if=$1 of=$2 bs=1k > /tmp/dd.$$ 2>&1 
    if [ $? -ne 0 ]; then
      echo "****  Error writing $1 boot image file to $2"
      cat /tmp/dd.$$
      echo "****  Resque Disk will not be installed"
      echo "****  fix the problem and try again"
      rm -f /tmp/dd.$$
      return 1
    fi
    rm -f /tmp/dd.$$
    if rdev $2 $2 && rdev -r $2 $offset ; then
      echo done
    else
      echo
      echo "****  Error running rdev command"
      echo "****  Resque Disk will not be installed"
      echo "****  fix the problem and try again"
      return 1
    fi
    printf "Installing ./disk root disk on $2 ..."
    if [ ! -d ./disk ]; then
      echo
      echo "****  Cannot find ./disk subdirectory"
      echo "****  root disk will not be installed"
      return 1
    fi
    if [ -z "$(lsmod | grep loop)" ]; then
      echo
      echo "****  loop.o module is not loaded"
      echo "****  root disk will not be installed"
      echo "****  load loop.o module and try again"
      return 1
    fi
    dd if=/dev/zero of=/tmp/rootdisk.$$ bs=1k count=4096 > /dev/null 2>&1
    echo "y" | mke2fs -m 0 -N 300 /tmp/rootdisk.$$ > /tmp/dd.$$ 2>&1
    if [ $? -ne 0 ]; then
      echo
      echo "****  Error creating ext2 filesystem on loopback device"
      cat /tmp/dd.$$
      echo "****  root disk will not be installed"
      echo "****  fix the problem and try again"
      rm -f /tmp/dd.$$ /tmp/rootdisk.$$
      return 1
    fi
    rm -f /tmp/dd.$$
    mkdir /mnt.$$
    mount -o loop -t ext2 /tmp/rootdisk.$$ /mnt.$$ > /tmp/dd.$$ 2>&1
    if [ $? -ne 0 ]; then
      echo
      echo "****  Error mounting ext2 filesystem on loopback device"
      cat /tmp/dd.$$
      echo "****  root disk will not be installed"
      echo "****  fix the problem and try again"
      rm -f /tmp/dd.$$ /tmp/rootdisk.$$ /mnt.$$
      return 1
    fi
    rm -f /tmp/dd.$$
    rm -r /mnt.$$/lost+found
    cd ./disk
    find . -print | cpio -p -dm /mnt.$$ > /tmp/dd.$$ 2>&1
    if [ $? -ne 0 ]; then
      echo "****  Error copying files from ./disk to /mnt.$$"
      cat /tmp/dd.$$
      echo "****  fix the problem and try again"
      rm -f /tmp/dd.$$
      umount /mnt.$$
      rm -r /mnt.$$ 
      rm -f /tmp/rootdisk.$$
      return 1
    fi
    cd -
    umount /mnt.$$
    rm -r /mnt.$$
    gzip -9 -f /tmp/rootdisk.$$
    cp /tmp/rootdisk.$$.gz rootdisk.gz
    dd if=/tmp/rootdisk.$$.gz of=$2 bs=1k seek=$image_size > /tmp/dd.$$ 2>&1 
    if [ $? -ne 0 ]; then
      echo
      echo "****  Error installing rootdisk to $2 device"
      cat /tmp/dd.$$
      echo "****  Perhaps your root disk image is too large"
      echo "****  fix the problem and try again"
      rm -f /tmp/dd.$$ /tmp/rootdisk.$$.gz
      return 1
    fi
    echo done
    rm -f /tmp/dd.$$ /tmp/rootdisk.$$.gz
    echo "Now you can try your brand new Resque Disk"
    return 0
  fi
  return 1
fi
echo "****  Cannot find or read $1 boot image file"
echo "****  Resque Disk will not be installed"
return 1
}

if type dd > /dev/null && \
   type rdev > /dev/null && \
   type rm > /dev/null && \
   type cat > /dev/null && \
   type cut > /dev/null && \
   type grep > /dev/null && \
   type sed > /dev/null && \
   type lsmod > /dev/null && \
   type mke2fs > /dev/null && \
   type mkdir > /dev/null && \
   type find > /dev/null && \
   type cpio > /dev/null && \
   type mount > /dev/null && \
   type umount > /dev/null && \
   type printf > /dev/null && \
   type gzip > /dev/null
then
  if [ $# -eq 2 ]; then
    printf "Put formatted diskette into your floppy drive, press Enter .."
    read ans
    instt $1 $2 || exit 1
  else
    echo "Usage: install_custom.sh bootimage bootdevice"
    exit 1
  fi
else
  echo "****  Cannot find one or more of the following programs:"
  echo "****  dd rdev rm cat cut grep sed lsmod mke2fs mkdir find cpio mount umount printf gzip"
  echo "****  Make sure they are available in your path and try again"
  exit 1
fi
exit 0
